//---------------------------------------------------------------------------//
//
//	Sample Garden - Main
//
//	Date : 2008/04/18
//
//---------------------------------------------------------------------------//

#include "main.h"

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nShowCmd)
{
	CSampleGardenConfig Config;
	_tcscpy(Config.m_szAppName, _T("Sample Garden"));
	_tcscpy(Config.m_szClassName, _T("_SAMPLE_GARDEN_CLASS_"));
	Config.m_nWidth = 800;
	Config.m_nHeight = 600;
	Config.m_bFullScreen = false;
	Config.m_nFPS = 60;

	CSampleGarden App;
	App.Init(&Config);
	App.Initialize();
	App.Run();
	App.FinalRelease();
	App.Release();

	return true;
}
//---------------------------------------------------------------------------//
//	Sample Garden Class
//---------------------------------------------------------------------------//

//! ҽ εѴ.
bool CSampleGarden::Initialize()
{
	m_pSampleTex = new CTexture;
	m_pSampleTex->Load(_T("texture\\Character Cat Girl.png"));

	m_pBackTex = new CTexture;
	m_pBackTex->Load(_T("texture\\Grass Block.png"));

	m_pTreeShort = new CTexture;
	m_pTreeShort->Load(_T("texture\\tree ugly.png"));

	m_pTreeTall = new CTexture;
	m_pTreeTall->Load(_T("texture\\tree Tall.png"));

	m_pGem = new CTexture;
	m_pGem->Load(_T("texture\\gem orange.png"));

	m_pRock = new CTexture;
	m_pRock->Load(_T("texture\\rock.png"));

	m_pDoor = new CTexture;
	m_pDoor->Load(_T("texture\\Door Tall Closed.png"));

	m_pKey = new CTexture;
	m_pKey->Load(_T("texture\\Key.png"));

	m_pJewelB = new CTexture;
	m_pJewelB->Load(_T("texture\\Gem Blue.png"));

	m_pJewelG = new CTexture;
	m_pJewelG->Load(_T("texture\\Gem Green.png"));

	m_pJewelY = new CTexture;
	m_pJewelY->Load(_T("texture\\Gem Orange.png"));

	m_x = m_y = 0;

	m_wx = 1600;

	return true;
}

//! ε ҽ Ѵ.
void CSampleGarden::FinalRelease()
{
	SAFE_DELETE(m_pSampleTex);
	SAFE_DELETE(m_pBackTex);
	SAFE_DELETE(m_pTreeShort);
	SAFE_DELETE(m_pGem);
	SAFE_DELETE(m_pRock);

	SAFE_DELETE(m_pDoor);
	SAFE_DELETE(m_pKey);
	SAFE_DELETE(m_pJewelB);
	SAFE_DELETE(m_pJewelG);
	SAFE_DELETE(m_pJewelY);
}

//! 1ʸ  Ӹŭ Ʈ Ѵ.
int CSampleGarden::Update()
{
	if (DIKPress(DIK_F5))
		m_bLoop = false;

	if (DIKRepeat(DIK_UP))
	{
		m_y -= 4;
	}
	else if (DIKRepeat(DIK_DOWN))
	{
		m_y += 4;
	}
	if (DIKRepeat(DIK_LEFT))
	{
		m_x -= 4;
	}
	else if (DIKRepeat(DIK_RIGHT))
	{
		m_x += 4;
	}

	int dx, dy, dz;
	DIMGetMovement(dx, dy, dz);
	m_wx -= dz/2;
	clamp(m_wx, 400, 1600);

	return true;
}

//! Ʈ ͸ ȭ鿡 Ѵ. Ʈ ϰ  ð  ȴ.
void CSampleGarden::Render()
{
	m_pRenderer->ClearBuffer(true, 0x00000000, true);

	m_pRenderer->BeginScene();
	m_pRenderer->BeginDrawTexture(m_wx, m_wx/4*3);

	// layer 1
	for (int y=0; y<8; ++y)
	{
		for (int x=0; x<12; ++x)
		{
			m_pRenderer->DrawTexture(m_pBackTex, 32+x*128, y*128);
		}
	}

	m_pRenderer->DrawTexture(m_pSampleTex, m_x, m_y);
	


	// layer 2
	m_pRenderer->DrawTexture(m_pRock, 32+3*128, 0*128-58);// ̴ 
	m_pRenderer->DrawTexture(m_pJewelB, 32+4*128, 0*128-58);
	m_pRenderer->DrawTexture(m_pRock, 32+8*128, 0*128-58);
	m_pRenderer->DrawTexture(m_pRock, 32+10*128, 0*128-58);// ̴ 
	m_pRenderer->DrawTexture(m_pTreeShort, 32+5*128, 0*128-58);
	m_pRenderer->DrawTexture(m_pTreeShort, 32+6*128, 0*128-58);
	m_pRenderer->DrawTexture(m_pTreeShort, 32+11*128, 0*128-58);
	
    m_pRenderer->DrawTexture(m_pRock, 32+1*128, 1*128-58);
	m_pRenderer->DrawTexture(m_pRock, 32+2*128, 1*128-58);
	m_pRenderer->DrawTexture(m_pRock, 32+3*128, 1*128-58);
	m_pRenderer->DrawTexture(m_pRock, 32+5*128, 1*128-58);
	m_pRenderer->DrawTexture(m_pRock, 32+7*128, 1*128-58);
	m_pRenderer->DrawTexture(m_pRock, 32+10*128, 1*128-58);// ̴ 
	m_pRenderer->DrawTexture(m_pTreeShort, 32+11*128, 1*128-58);

	m_pRenderer->DrawTexture(m_pTreeShort, 32+0*128, 2*128-58);
	m_pRenderer->DrawTexture(m_pRock, 32+1*128, 2*128-58);
	m_pRenderer->DrawTexture(m_pTreeShort, 32+2*128, 2*128-58);  
	m_pRenderer->DrawTexture(m_pTreeShort, 32+3*128, 2*128-58);
	m_pRenderer->DrawTexture(m_pRock, 32+4*128, 2*128-58);// ̴ 
	m_pRenderer->DrawTexture(m_pRock, 32+5*128, 2*128-58);
	m_pRenderer->DrawTexture(m_pJewelG, 32+4*128, 0*128-58);
	m_pRenderer->DrawTexture(m_pRock, 32+7*128, 2*128-58);
	m_pRenderer->DrawTexture(m_pDoor, 32+9*128, 2*128-58);//door
	m_pRenderer->DrawTexture(m_pRock, 32+10*128, 2*128-58);
	m_pRenderer->DrawTexture(m_pJewelY, 32+11*128, 0*128-58);
	
	m_pRenderer->DrawTexture(m_pTreeShort, 32+0*128, 3*128-58);
	m_pRenderer->DrawTexture(m_pRock, 32+1*128, 3*128-58);
	m_pRenderer->DrawTexture(m_pKey, 32+2*128, 3*128-58);//key
	m_pRenderer->DrawTexture(m_pRock, 32+3*128, 3*128-58);
	m_pRenderer->DrawTexture(m_pRock, 32+6*128, 3*128-58);// ̴ 
	m_pRenderer->DrawTexture(m_pRock, 32+7*128, 3*128-58);
	m_pRenderer->DrawTexture(m_pRock, 32+8*128, 3*128-58);
	m_pRenderer->DrawTexture(m_pRock, 32+9*128, 3*128-58);

	
	m_pRenderer->DrawTexture(m_pTreeTall, 32+0*128, 4*128-58);
	m_pRenderer->DrawTexture(m_pJewelG, 32+1*128, 4*128-58);
	m_pRenderer->DrawTexture(m_pRock, 32+2*128, 4*128-58);
	m_pRenderer->DrawTexture(m_pRock, 32+3*128, 4*128-58);// ̴ 
	m_pRenderer->DrawTexture(m_pRock, 32+5*128, 4*128-58);
	m_pRenderer->DrawTexture(m_pRock, 32+7*128, 4*128-58);
	m_pRenderer->DrawTexture(m_pJewelB, 32+8*128, 4*128-58);
	m_pRenderer->DrawTexture(m_pTreeShort, 32+9*128, 4*128-58);
	m_pRenderer->DrawTexture(m_pTreeShort, 32+10*128, 4*128-58);
	m_pRenderer->DrawTexture(m_pTreeShort, 32+11*128, 4*128-58);


	m_pRenderer->DrawTexture(m_pTreeTall, 32+0*128, 5*128-58);
	m_pRenderer->DrawTexture(m_pRock, 32+1*128, 5*128-58);// ̴ 
	m_pRenderer->DrawTexture(m_pRock, 32+4*128, 5*128-58);
	m_pRenderer->DrawTexture(m_pJewelY, 32+5*128, 5*128-58);
	m_pRenderer->DrawTexture(m_pRock, 32+9*128, 5*128-58);
	m_pRenderer->DrawTexture(m_pRock, 32+10*128, 5*128-58);
	
	m_pRenderer->DrawTexture(m_pRock, 32+1*128, 6*128-58);
	m_pRenderer->DrawTexture(m_pJewelG, 32+2*128, 6*128-58);
	m_pRenderer->DrawTexture(m_pRock, 32+3*128, 6*128-58);
	m_pRenderer->DrawTexture(m_pTreeTall, 32+4*128, 6*128-58);
	m_pRenderer->DrawTexture(m_pKey, 32+5*128, 6*128-58);
	m_pRenderer->DrawTexture(m_pRock, 32+7*128, 6*128-58);
	m_pRenderer->DrawTexture(m_pRock, 32+8*128, 6*128-58);// ̴ 

	m_pRenderer->DrawTexture(m_pRock, 32+1*128, 7*128-58);
	m_pRenderer->DrawTexture(m_pJewelY, 32+3*128, 7*128-58);
	m_pRenderer->DrawTexture(m_pRock, 32+5*128, 7*128-58);
	m_pRenderer->DrawTexture(m_pTreeShort, 32+6*128, 7*128-58);
	m_pRenderer->DrawTexture(m_pTreeShort, 32+7*128, 7*128-58);
	m_pRenderer->DrawTexture(m_pRock, 32+10*128, 7*128-58);
	m_pRenderer->DrawTexture(m_pRock, 32+11*128, 7*128-58);
	

	// layer3
    m_pRenderer->DrawTexture(m_pRock, 32+2*128, 3*128-58);
	m_pRenderer->DrawTexture(m_pTreeTall, 32+5*128, 6*128-58);




	
	m_pRenderer->EndDrawTexture();
	m_pRenderer->EndScene();

	static TCHAR szBuff[256];
	_stprintf(szBuff, _T("fps : %4.2f"), m_fRenderFps, m_pTimerSync->GetFps());
	m_pRenderer->DrawTextDC(15, 15, szBuff, RGB(255, 255, 255));
	
	m_pRenderer->Present();
}