//---------------------------------------------------------------------------//
//
//	Core
//
//	created : 2008/04/07
//
//---------------------------------------------------------------------------//

#pragma once

#pragma warning (disable : 4267)

#include "core_std.h"

using namespace std;

#define SAFE_DELETE(x)			if (x) { delete x; x = NULL; }
#define SAFE_DELETE_ARRAY(x)	if (x) { delete [] x; x = NULL; }
#define SAFE_RELEASE(x)			if (x) { x->Release(); x=NULL; }

#ifdef _UNICODE
	typedef std::wstring			tstring;
	typedef std::wfstream			tfstream;
	typedef std::wifstream			tifstream;
	typedef std::wofstream			tofstream;
#else
	typedef std::string				tstring;
	typedef std::fstream			tfstream;
	typedef std::ifstream			tifstream;
	typedef std::ofstream			tofstream;
#endif

typedef short					int16;
typedef unsigned short			uint16;
typedef long					int32;
typedef unsigned long			uint32;
typedef std::vector<tstring>	StringArray;
typedef StringArray::iterator	StringArrayItor;

//! Ư   ġ ۾ ϰ Ѵ.
template <class T>
inline const T& minimum(const T& a, const T& b)
{
	return a < b ? a : b;
}

//! Ư   ġ Ŀ ϰ Ѵ.
template <class T>
inline const T& maximum(const T& a, const T& b)
{
	return a > b ? a : b;
}

//! Ư  ȿ  Ѵ.
template <class T>
inline void clamp(T& value, const T& min, const T& max)
{
	if (value < min)
	{
		value = min;
	}
	else if (value > max)
	{
		value = max;
	}
}