//---------------------------------------------------------------------------//
//
//	Core - Singleton
//
//	created : 2008/02/19
//
//---------------------------------------------------------------------------//

#pragma once

#include <assert.h>

//! ̱ ø Ŭ ( ޴ Ŭ singleton  .)
template <class T>
class CSingleton
{
private:
	static T* m_pSingleton;

public:
	CSingleton() 
	{
		m_pSingleton = static_cast<T*>(this);
	}
	~CSingleton() { m_pSingleton = NULL; }

	static T& GetInstance() 
	{
		if (!m_pSingleton)
		{
			m_pSingleton = new T;
		}
		return (*m_pSingleton);
	}
	static T* GetInstancePtr() 
	{
		if (!m_pSingleton)
		{
			m_pSingleton = new T;
		}
		return m_pSingleton; 
	}
	static void DeleteInstance() 
	{ 
		if (m_pSingleton)
		{
			delete m_pSingleton; 
			m_pSingleton=NULL; 
		}
	}
};

template <class T> 
T* CSingleton<T>::m_pSingleton = NULL;