//---------------------------------------------------------------------------//
//
//	Framework - Win32 Application
//
//	Date : 2008/04/07
//
//---------------------------------------------------------------------------//

#pragma once

#include "framework_config.h"
#include "core.h"

//! 츦  ӿũ ° 
class FRAMEWORK_API CWindowApp
{
protected:
	tstring		m_strAppName, m_strClassName;
	HWND		m_hWnd;
	WNDCLASS	m_WndClass;
	bool		m_bEnableIdle, m_bLoop;

public:
	CWindowApp();
	CWindowApp(const tstring& strAppName, int x, int y, int width, int height);
	virtual ~CWindowApp();

	//! 츦 ʱȭϰ ڿ ° Ѵ.
	HRESULT	Create(const tstring& strAppName, const tstring& strClassName, 
				   int x, int y, int width, int height, 
				   int style=(WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX), 
				   HMENU hMenu=NULL, int icon=0, int cursor=0);

	//! 찡 ޽ óϰ  ð ̺κ óȴ.   η  ȴ.
	void SetIdle(bool bEnable);
	//!  ޽ 
	virtual void MsgLoop();
	//! 찡 ޽ óϰ  ð ̺κ óȴ.   η  ȴ.
	virtual void Idle();
	//!  ޽ ν
	virtual LRESULT WndProc(HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam);
	
	operator HWND() const;

	HWND GetHwnd() { return m_hWnd; }
	HINSTANCE GetHinstance() { return m_WndClass.hInstance; }
	
	inline bool IsAlive();
	inline const tstring& GetAppName();
	inline const tstring& GetClassName();

private:
	static LRESULT CALLBACK StaticWndProc(HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam);

	//! Ŭ̾Ʈ  ũ⸦ width height Ѵ.
	void SetClientSize(int nWidth, int nHeight);
};

bool CWindowApp::IsAlive()
{ 
	return m_bLoop; 
}

const tstring& CWindowApp::GetAppName()
{
	return m_strAppName;
}

const tstring& CWindowApp::GetClassName()
{
	return m_strClassName;
}
